%% Initialize 
motion_case=1; 
if motion_case==1
    T=3.19;
    x0 = [0;4.3];
elseif motion_case==2
    T=4.8192;
    x0 = [0;4.1];
elseif motion_case==3
    T=3.19;
    x0 = [0;-4.3];
end
get_prop; 
get_spline;
options = odeset('RelTol',1e-5,'AbsTol',1e-6); 
t0 = 0; tend = T; Nsim = 100; 
tspan = linspace(t0,tend ,Nsim); 

%% Simulation of dynamics 
[t,x] = ode23(@(t,y)get_dynamics(t,y,prop),tspan ,x0,options);

varphi_nom = x(1:Nsim ,1); d_varphi_nom = x(1:Nsim ,2); 
u_nom=zeros(1,Nsim); Fn_nom=zeros(1,Nsim); Fs_nom=zeros(1,Nsim);
for i=1:Nsim 
    [u_nom(i),Fn_nom(i), Fs_nom(i)] = get_u_forces([varphi_nom(i); d_varphi_nom(i)],prop); 
end
mu = 1/min(abs(Fn_nom./Fs_nom)); 

subplot (2,2,1), plot(x(1:100,1),x(1:100,2))
xlabel('varphi') 
ylabel('d_varphi'), 
subplot (2,2,2), plot(t,x)
xlabel('t [s]')
legend({'varphi[rad]','d_varphi [rad/s]'},'orientation','horizontal'), 
subplot(2,2,3),plot(t(1:Nsim),u_nom)
xlabel('t [s]') 
ylabel('Input u [Nm]'); 
subplot(2,2,4),plot(t(1:Nsim),Fn_nom)
hold on 
plot(t(1:Nsim),Fs_nom)
hold off
xlabel('t [s]') 
legend({'Fn[N]','Fs[N]'},'orientation','horizontal');

