get_prop; 
get_spline;

options = odeset('RelTol',1e-5,'AbsTol',1e-6); 
t0 = 0; tend = 5; Nsim = 100; 
tspan = linspace(t0,tend ,Nsim); 
x0 = [0;4.45];
T=8.97;

prop.c=0.48;
[t,x] = ode23(@(t,y)get_dynamics(t,y,prop),tspan ,x0,options);
Nres1 =find(x(:,1) >2*pi,1); 
varphi_nom1 = x(1:Nres1 ,1); d_varphi_nom1 = x(1:Nres1 ,2); 
t1=t(1:Nres1);

prop.c=0.45;
x0=[x(Nres1+1,1),x(Nres1+1,2)];
tspan=linspace(t(Nres1+1),t(Nres1+1)+5,Nsim);
[t,x] = ode23(@(t,y)get_dynamics(t,y,prop),tspan ,x0,options);
Nres2 =find(x(:,1) <2*pi ,1); 
varphi_nom2 = x(1:Nres2 ,1); d_varphi_nom2 = x(1:Nres2 ,2);
t2=t(1:Nres2);

prop.c=0.48;
x0=[x(Nres2+1,1),x(Nres2+1,2)];
tspan=linspace(t(Nres2+1),t(Nres2+1)+5,Nsim); %%%%%%t2 por t(Nres2+1)
[t,x] = ode23(@(t,y)get_dynamics(t,y,prop),tspan ,x0,options);
Nres3 =find(x(:,1) <0 ,1); 
varphi_nom3 = x(1:Nres3 ,1); d_varphi_nom3 = x(1:Nres3 ,2);
t3=t(1:Nres3);

prop.c=0.45;
x0=[x(Nres3+1,1),x(Nres3+1,2)];
tspan=linspace(t(Nres3+1),t(Nres3+1)+5,Nsim);
[t,x] = ode23(@(t,y)sim_dynamics(t,y,prop),tspan ,x0,options);
Nres4 =find(x(:,1) >0 ,1); 
varphi_nom4 = x(1:Nres4 ,1); d_varphi_nom4 = x(1:Nres4 ,2);
t4=t(1:Nres4);

prop.c=0.48;
x0=[x(Nres4+1,1),x(Nres4+1,2)];
tspan=linspace(t(Nres4+1),t(Nres4+1)+5,Nsim); 
[t,x] = ode23(@(t,y)get_dynamics(t,y,prop),tspan ,x0,options);
Nres5 =find(x(:,1) >2*pi ,1); 
varphi_nom5 = x(1:Nres5 ,1); d_varphi_nom5 = x(1:Nres5 ,2);
t5=t(1:Nres5);

varphi_nom=[varphi_nom1; varphi_nom2; varphi_nom3; varphi_nom4; varphi_nom5];
d_varphi_nom=[d_varphi_nom1; d_varphi_nom2; d_varphi_nom3; d_varphi_nom4; d_varphi_nom5];
Nres=Nres1+Nres2+Nres3+Nres5;
t=[t1; t2; t3; t4; t5];
 
u_nom=zeros(1,Nres); Fn_nom=zeros(1,Nres); Fs_nom=zeros(1,Nres); 
for i=1:Nres 
    if i<=Nres1 || (i>Nres2 && i<=Nres3)|| (i>Nres4)
    prop.c=0.48;
    elseif (i>Nres1 && i<=Nres2) || (i>=Nres3&& i<=Nres4)
    prop.c=0.45;      
   
    end
    [u_nom(i),Fn_nom(i), Fs_nom(i)] = get_u_forces([varphi_nom(i); d_varphi_nom(i)],prop);
    
end

mu = 1/min(abs(Fn_nom./Fs_nom));  

subplot (2,2,1), plot(varphi_nom,d_varphi_nom)
xlabel('varphi') 
ylabel('d_varphi'), 
subplot (2,2,2), plot(t,varphi_nom);
hold on 
plot(t,d_varphi_nom);
xlabel('t [s]')
legend({'varphi [rad]','d_varphi [rad/s]'},'orientation','horizontal'), 
subplot(2,2,3),plot(t(1:Nres),u_nom)
xlabel('t [s]') 
ylabel('Input u [Nm]');
subplot(2,2,4),plot(t(1:Nres),Fn_nom)
hold on 
plot(t(1:Nres),Fs_nom)
hold off
xlabel('t [s]') 
legend({'Fn[N]','Fs[N]'},'orientation','horizontal')