%% Get all parameters 
phi = ppval(prop.phi_app ,varphi); 

delta = prop.a-prop.b*cos(2*phi); 
d_delta = 2*prop.b*sin(2*phi); 
dd_delta = 4*prop.b*cos(2*phi); 
ddd_delta = -8*prop.b*sin(2*phi);

xi = [sin(phi); cos(phi);0]; 

delta_vec = delta*xi; 
d_delta_vec = (d_delta*prop.I + delta*prop.Q)*xi; 
dd_delta_vec = (dd_delta*prop.I + 2*d_delta*prop.Q - delta*prop.I)*xi;

alpha = atan( (delta*sin(phi) - d_delta*cos(phi)) / (delta*cos(phi) + d_delta*sin(phi))); 
if phi > 0.5*pi && phi < 1.5*pi 
    alpha = alpha+pi; 
elseif phi >= 1.5*pi 
    alpha = alpha+2*pi; 
end

d_alpha = (2*d_delta^2 + delta^2 - dd_delta*delta)/(d_delta^2 + delta^2); 
dd_alpha = (2*delta*d_delta -delta*ddd_delta+3*d_delta*dd_delta)/(delta^2+d_delta^2) -(2*d_delta*(delta+dd_delta)*(delta^2-delta*dd_delta+2*d_delta^2))/((delta^2+d_delta^2)^2);

v1 = prop.R^2*dd_alpha+delta*(prop.R*sin(phi-alpha)+prop.R*sin(phi-alpha)*d_alpha^2+prop.R*cos(phi-alpha)*dd_alpha - 2*prop.R*sin(phi-alpha)*d_alpha)+prop.R*sin(phi-alpha)*dd_delta; 
v2 = delta^2 + prop.R^2+2*prop.R*cos(phi-alpha)*delta; 
v3 = (2*delta*d_delta+2*prop.R*cos(phi-alpha)*d_delta+2*prop.R*sin(phi-alpha)*delta*(d_alpha -1))*(prop.R^2*d_alpha -prop.R^2+prop.R*sin(phi-alpha)*d_delta+prop.R*cos(phi-alpha)*delta*(d_alpha -1)); 
v4 = v2^2; 

g = atan2(delta*sin(phi)+prop.R*sin(alpha),delta*cos(phi)+prop.R*cos(alpha)); 
d_g = (delta^2+prop.R^2*d_alpha+prop.R*delta*cos(phi-alpha)+prop.R*d_delta*sin(phi-alpha)+prop.R*d_alpha*delta*cos(phi-alpha))/v2; 
dd_g = v1/v2 - v3/v4;

n = [sin(alpha); cos(alpha);0];
d_n = [cos(alpha); -sin(alpha);0]*d_alpha; 
dd_n = [-sin(alpha)*d_alpha^2+cos(alpha)*dd_alpha; -cos(alpha)*d_alpha^2-sin(alpha)*dd_alpha;0];

rho = delta_vec + prop.R*n; 
h = d_delta_vec + prop.R*d_n; 
d_h = dd_delta_vec + prop.R*dd_n; 

tau = d_delta_vec/norm(d_delta_vec);

kappa_f = norm(cross(d_delta_vec ,dd_delta_vec))/(norm(d_delta_vec)^3); 
kappa_c = kappa_f/(1-prop.R*kappa_f); 
kappa = kappa_c*n;

p = 1/(prop.R*(prop.R*kappa_f -1));

d_s = norm(h)/d_g; 
dd_s = dot(h,d_h)/(norm(h)*d_g^2) - norm(h)*dd_g/(d_g^3);

Theta = varphi -prop.c*sin(2*varphi); %%%%%   VHC   %%%%%
d_Theta = 1-2*prop.c*cos(2*varphi); 
dd_Theta = 4*prop.c*sin(2*varphi);

