prop.m_b = 3e-3; %mass of ball [kg] 
prop.R_b = 16.55e-3; %ball radius [m] 
prop.r_f = 12.5e-3; %distance between plates [m] 
prop.R = sqrt(prop.R_b^2 - prop.r_f^2); %effective rolling radius [m] 
prop.J_b = 5.48e-7; %moment of inertia of ball [kg*m^2] 
prop.J_f = 1.581e-3; %moment of inertia of the frame [kg*m^2] 
prop.grav = [0; 9.81; 0]; %gravitational acceleration [m*s^2] 
prop.a = 0.1095; %bf frame
prop.b = 0.0405; %bf frame 
prop.c = 0.49; %VHC parameter 
prop.k_hat = [0; 0; 1]; %z-axis (rotation) 
prop.B = [1;0]; %Coupling matrix 
prop.B_an = [0 1]; %Annihalitor matrix 
prop.I = eye(3); %3x3 identity matrix 
prop.Q = [0 1 0; -1 0 0; 0 0 0]; %Matrix used for differentiation

N = 100; a_phi = linspace(0,2*pi,N); %phi array 
g=zeros(1,N); 
alphas=zeros(1,N);%%%%%%%
alphas2=zeros(1,N);%%%%%%%
for i = 1:N 
phi = a_phi(i); 
delta = prop.a-prop.b*cos(2*phi); 
d_delta = 2*prop.b*sin(2*phi); 
alpha = atan((delta*sin(phi)-d_delta*cos(phi))/(delta*cos(phi)+d_delta*sin(phi))); 
alphas(i)=alpha;
if phi > 0.5*pi && phi < 1.5*pi %%between 90 and 270 degrees
    alpha = alpha+pi; %%si no dara negativos.
elseif phi >= 1.5*pi 
  alpha = alpha+2*pi; %%si no dara negativos.
end
alphas2(i)=alpha;%%%%%%%%%%
g(i) = atan2(delta*sin(phi)+prop.R*sin(alpha),delta*cos(phi)+prop.R*cos(alpha));
end 
g = mod(g,2*pi); %%divide todo el vector entre 2*pi y saca todos los restos 
g = unwrap(g*2)/2; %%obtiene todos los g's desde 0 hasta 2*pi
prop.phi_app = spline(g,a_phi); %save in struct par , to access it in simulation
phi = ppval(prop.phi_app ,pi); %read out spline: phi = f(varphi)
